//
//  CurrencyConverterView.m
//  Calcolatrice
//
//  Created by valvoline on 10/29/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "CurrencyConverterView.h"

@implementation CurrencyConverterView

- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
		[self setBackgroundColor:[UIColor grayColor]];
		for(int i=0;i<2;i++) {
			for(int j=0;j<5;j++) {
				UIButton *tempButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
				[tempButton setFrame:CGRectMake(j*64, (i*64)+100, 60, 60)];
				[tempButton setTitle:[NSString stringWithFormat:@"%d", j+(i*5)]  forState:UIControlStateNormal];
				[tempButton addTarget:self action:@selector(numberPressed:) forControlEvents:UIControlEventTouchUpInside];
				[self addSubview:tempButton];
			}
		}
		operazioni = [[NSMutableArray alloc] init];
		[operazioni addObject:[NSString stringWithString:@"€->$"]]; //0
		[operazioni addObject:[NSString stringWithString:@"$->€"]]; //1
		[operazioni addObject:[NSString stringWithString:@"CA"]]; //2
		for(int j=0;j<4;j++) {
			if(j==0) {
				UIButton *tempButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
				[tempButton setFrame:CGRectMake(j*64, (2*64)+100, 60, 60)];
				[tempButton setTitle:[NSString stringWithString:@"."] forState:UIControlStateNormal];
				[tempButton addTarget:self action:@selector(numberPressed:) forControlEvents:UIControlEventTouchUpInside];
				[self addSubview:tempButton];
			} else {
				UIButton *tempButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
				[tempButton setFrame:CGRectMake(j*64, (2*64)+100, 60, 60)];
				[tempButton setTitle:[operazioni objectAtIndex:j-1] forState:UIControlStateNormal];
				[tempButton addTarget:self action:@selector(operationPressed:) forControlEvents:UIControlEventTouchUpInside];
				[self addSubview:tempButton];
			}
		}
		myDiplay = [[UILabel alloc] initWithFrame:CGRectMake(5, 20, 310, 60)];
		[myDiplay setBackgroundColor:[UIColor lightGrayColor]];
		[myDiplay setTextColor:[UIColor blackColor]];
		[myDiplay setText:[NSString stringWithString:@"0.00"]];
		[myDiplay setTextAlignment:UITextAlignmentRight];
		[self addSubview:myDiplay];
		[myDiplay release];
	}
    return self;
}

-(NSString *)displayedValue {
	NSString *mystring = [NSString stringWithString:myDiplay.text];
	return mystring;
}

-(void) setDisplayedValue:(NSString *)newValue {
	[myDiplay setText:[NSString stringWithString:newValue]];
}

-(void)numberPressed:(id)sender {
	UIButton *tmp = sender;
	if([myDiplay.text isEqualToString:@"0.00"]) {
		myDiplay.text = [NSString stringWithFormat:@"%@", tmp.currentTitle];
	} else {
		myDiplay.text = [NSString stringWithFormat:@"%@%@", myDiplay.text, tmp.currentTitle];
	}
}

-(void) operationPressed:(id)sender {
	int i;
	UIButton *tmp = sender;
	for(i=0;i<[operazioni count];i++) {
		if([tmp.currentTitle isEqualToString:[operazioni objectAtIndex:i]]) {
			break;
		}
	}
	switch (i) {
		case 0:
			resultValue = ([myDiplay.text floatValue] / 1.47200);
			break;
		case 1:
			resultValue = ([myDiplay.text floatValue] / 0.679347826);
			break;
		case 2:
			resultValue = 0;
			break;
	}
	myDiplay.text = [NSString stringWithFormat:@"%.2f", resultValue];
}

- (void)dealloc {
	[operazioni release];
    [super dealloc];
}


@end
